import org.videolan.jvlc.JVLC;
import org.videolan.jvlc.MediaDescriptor;
import org.videolan.jvlc.MediaPlayer;
import org.videolan.jvlc.Video;


public class DvbRip {
	
	private static final String VERSION = "0.1";
	
	private static void usage() {
		System.out.println("parameter: ");
		System.out.println("   url: filesource (needed argument)");
		System.out.println("   snapshotSize: size of snapshot image, 0 means no resize");
		System.out.println("   snapshotDir: snapshot directory");
		System.out.println("   noVerbose: disable vlc verbose messages");
		System.out.println("   vlcPluginPath: path to vlc plugin directory");
		System.out.println("   snapshotPrefix: prefix for snapshot files");
		System.out.println("   noVideoOut: disable video output");
		System.out.println("   crop: crop video, aspect ration 1:1");
		System.out.println("   noSnapshotPreview: do not display snapshot preview");
		System.out.println("   initWaitTime: wait until connection is established, default 3000ms");		
		System.out.println();
		System.out.println("example:");
		System.out.println("   java -classpath .;%classpath%;jvlc-core-1.0.0-SNAPSHOT.jar;jna.jar DvbRip snapshotPrefix=p1 url=http://192.168.111.15:8001/1:0:1:3:45:1:FFFF018A:0:0:0: snapshotDir=C:\\ initWaitTime=5000");
		System.exit(0);
	}
	
	/**
	 * @param args
	 * @throws InterruptedException 
	 */
	public static void main(String[] args) throws InterruptedException {
	    String media = "";
        String snapshotDir = "";
        String vlcVout = "";
        String vlcCrop = "";
        String vlcVerbose = "-vvv";
        String vlcPluginPath="c:\\Programme\\VideoLAN\\VLC\\plugins";
        String vlcSnapshotPreview="";
        String snapshotPrefix = "S_";
        int snapshotSize=0;
	int initWaitTime=3000;
        boolean urlParameterExists=false;

        System.out.println("#neophob.com DvbRip <v"+VERSION);

        if (args.length < 1) {
        	usage();
        }
        
        for (String s: args) {
        	//System.out.println("PARAMETER: "+s);        	
        	if (s.startsWith("snapshotSize")) {
        		snapshotSize = Integer.parseInt(s.split("=")[1]);
        	}       	
        	if (s.startsWith("initWaitTime")) {
        		initWaitTime = Integer.parseInt(s.split("=")[1]);
        	}
        	if (s.startsWith("snapshotPrefix")) {
        		snapshotPrefix = s.split("=")[1];
        	}        	
        	if (s.startsWith("url")) {
        		media = s.split("=")[1];
        		urlParameterExists = true;
        	}
        	if (s.startsWith("snapshotDir")) {
        		snapshotDir = s.split("=")[1];
        	}
        	if (s.startsWith("noVerbose")) {
        		vlcVerbose = ""; 
        	}        	
        	if (s.startsWith("vlcPluginPath")) {
        		vlcPluginPath = s.split("=")[1];
        	}        	       
        	if (s.startsWith("noVideoOut")) {
        		vlcVout="--vout=dummy";
        	}        	       
        	if (s.startsWith("crop")) {
        		vlcCrop="--crop=1:1";
        	}
        	if (s.startsWith("noSnapshotPreview")) {
        		vlcSnapshotPreview="--no-snapshot-preview";
        	}
        	
        }
        
        if (!urlParameterExists) {
        	usage();
        }
        
        String[] vlcParameter = new String[] { 
        		"--plugin-path="+vlcPluginPath,
        		"--no-audio",
        		vlcVerbose,
        		vlcVout,
        		vlcSnapshotPreview,
        		"--no-overlay",
        		vlcCrop
        };
                
        System.out.println("## init jvlc");
        JVLC jvlc = new JVLC(vlcParameter);
        MediaDescriptor mediaDescriptor = new MediaDescriptor(jvlc, media);
        MediaPlayer mp = mediaDescriptor.getMediaPlayer();

        mp.play();
        Thread.sleep(initWaitTime);

        String fname = snapshotDir+snapshotPrefix+"dvbsnapshot.png";
        System.out.println("## save snapshot "+fname);
        Video vid = new Video(jvlc);
        vid.getSnapshot(mp, fname, snapshotSize, snapshotSize);
  	
        System.out.println("## done");
        mp.stop();
        mediaDescriptor.release();
	}
}
